﻿using Microsoft.Extensions.Configuration;
using Microsoft.WindowsAzure.Storage;
using Microsoft.WindowsAzure.Storage.Table;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;

namespace HaBook.IES.AzureCloud.TableStorage.Repositorys
{
    public class AzureTableDBRepository : IAzureTableDBRepository

    {
        public IConfiguration Configuration { get; }
        private static CloudTableClient tableClient;
        private CloudTable _table;
        public AzureTableDBRepository(IConfiguration configuration)
        {

            Configuration = configuration;
            // _tableName = tableName;
            InitializeTable();
        }
        private async void InitializeTable()
        {
            string StorageConnectionString = "DefaultEndpointsProtocol=https;AccountName=teammodelstorage;AccountKey=Yq7D4dE6cFuer2d2UZIccTA/i0c3sJ/6ITc8tNOyW+K5f+/lWw9GCos3Mxhj47PyWQgDL8YbVD63B9XcGtrMxQ==;EndpointSuffix=core.chinacloudapi.cn";
            var storageAccount =  CloudStorageAccount.Parse(StorageConnectionString);
            tableClient = storageAccount.CreateCloudTableClient();
        }
        public T DeleteById<T>(object id) where T : new()
        {
            throw new NotImplementedException();
        }

        public List<T> FindAll<T>() where T : TableEntity, new()
        {
            Type t = typeof(T);
            CloudTable table = tableClient.GetTableReference(t.Name);
            var exQuery =  new TableQuery<T>();
            TableContinuationToken continuationToken = null;
            return table.ExecuteQuerySegmentedAsync(exQuery, continuationToken).Result.ToList<T>();
        }

        public T FindById<T>(string  id) where T : TableEntity, new()
        {
            Type t = typeof(T);
            CloudTable table = tableClient.GetTableReference(t.Name);
            var exQuery = new TableQuery<T>();
            if (string.IsNullOrEmpty(id) )
            {
                exQuery.Where(TableQuery.GenerateFilterCondition("Id", QueryComparisons.Equal, id));
            }
            //exQuery. Where(TableQuery.GenerateFilterCondition("PartitionKey", QueryComparisons.Equal,   partitionKey));
            // exQuery.Where(TableQuery.GenerateFilterCondition("Id", QueryComparisons.Equal,    "3e89fded-806f-454a-85fc-7f0360f5a8361"));
            TableContinuationToken continuationToken = null;
            return table.ExecuteQuerySegmentedAsync(exQuery, continuationToken).Result.Single<T>();
        }

        public List<T> FindListByDict<T>(Dictionary<string, object> dict) where T  : TableEntity, new()
        {
            Type t = typeof(T);
            CloudTable table = tableClient.GetTableReference(t.Name);

            // table = tableClient.GetTableReference(entity.GetType().Name.ToLower());
            var exQuery = new TableQuery<T>();
            if (null != dict && dict.Count > 0)
            {
                var keys = dict.Keys;
                foreach (String key in keys)
                {
                    if (dict[key] != null && !string.IsNullOrEmpty(dict[key].ToString()))
                    {
                        exQuery.Where(TableQuery.GenerateFilterCondition(key, QueryComparisons.Equal,
                                                                           dict[key].ToString()));
                    }
                }
            }
            //exQuery. Where(TableQuery.GenerateFilterCondition("PartitionKey", QueryComparisons.Equal,   partitionKey));
            // exQuery.Where(TableQuery.GenerateFilterCondition("Id", QueryComparisons.Equal,    "3e89fded-806f-454a-85fc-7f0360f5a8361"));
            TableContinuationToken continuationToken = null;
            return table.ExecuteQuerySegmentedAsync(exQuery, continuationToken).Result.ToList<T>();
        }

        public List<T> FindListByDictAndLike<T>(Dictionary<string, object> dict, Dictionary<string, object> likeDict) where T : TableEntity, new()
        {
            throw new NotImplementedException();
        }

        public List<T> FindListByDictAndLikeAndNotEQ<T>(Dictionary<string, object> dict, Dictionary<string, object> likeDict, Dictionary<string, object> notEQDict) where T : TableEntity, new()
        {
            throw new NotImplementedException();
        }

        public List<T> FindListByDictAndLikeAndStartWith<T>(Dictionary<string, object> dict, Dictionary<string, object> likeDict, Dictionary<string, object> startDict) where T : TableEntity, new()
        {
            throw new NotImplementedException();
        }

        public List<T> FindListByKey<T>(string key, string value) where T : TableEntity, new()
        {
            Type t = typeof(T);
            CloudTable table = tableClient.GetTableReference(t.Name);
            var exQuery = new TableQuery<T>();
            if (string.IsNullOrEmpty(key) && string.IsNullOrEmpty(value))
            {
                exQuery.Where(TableQuery.GenerateFilterCondition(key, QueryComparisons.Equal,  value));
            }
            //exQuery. Where(TableQuery.GenerateFilterCondition("PartitionKey", QueryComparisons.Equal,   partitionKey));
            // exQuery.Where(TableQuery.GenerateFilterCondition("Id", QueryComparisons.Equal,    "3e89fded-806f-454a-85fc-7f0360f5a8361"));
            TableContinuationToken continuationToken = null;
            return table.ExecuteQuerySegmentedAsync(exQuery, continuationToken).Result.ToList<T>();
        }

        public T FindOneByDict<T>(IDictionary<string, object> dict) where T : TableEntity, new()
        {
          
                Type t = typeof(T);
                CloudTable table = tableClient.GetTableReference(t.Name);

                // table = tableClient.GetTableReference(entity.GetType().Name.ToLower());
                var exQuery = new TableQuery<T>();
                if (null != dict && dict.Count > 0)
                {
                    var keys = dict.Keys;
                    foreach (String key in keys)
                    {
                        if (dict[key] != null && !string.IsNullOrEmpty(dict[key].ToString()))
                        {
                            exQuery.Where(TableQuery.GenerateFilterCondition(key, QueryComparisons.Equal,dict[key].ToString()));
                        }
                    }
                }
            //exQuery. Where(TableQuery.GenerateFilterCondition("PartitionKey", QueryComparisons.Equal,   partitionKey));
            // exQuery.Where(TableQuery.GenerateFilterCondition("Id", QueryComparisons.Equal,    "3e89fded-806f-454a-85fc-7f0360f5a8361"));
            exQuery.Where(TableQuery.CombineFilters(TableQuery.GenerateFilterCondition("", QueryComparisons.Equal, ""),"",""));
                TableContinuationToken continuationToken = null;
                return table.ExecuteQuerySegmentedAsync(exQuery, continuationToken).Result.Single<T>();
            }

        public T FindOneByKey<T>(string key, string value) where T : TableEntity , new()
        {
            Type t = typeof(T);
            CloudTable table = tableClient.GetTableReference(t.Name);
            var exQuery = new TableQuery<T>();
            if (string.IsNullOrEmpty(key) && string.IsNullOrEmpty(value))
            {
                exQuery.Where(TableQuery.GenerateFilterCondition(key, QueryComparisons.Equal,
                                                                          value));
            }
            //exQuery. Where(TableQuery.GenerateFilterCondition("PartitionKey", QueryComparisons.Equal,   partitionKey));
            // exQuery.Where(TableQuery.GenerateFilterCondition("Id", QueryComparisons.Equal,    "3e89fded-806f-454a-85fc-7f0360f5a8361"));
            TableContinuationToken continuationToken = null;
            return table.ExecuteQuerySegmentedAsync(exQuery, continuationToken).Result.Single<T>();
        }

        public List<T> GetEntities<T>(IDictionary<string, object> dict) where T : TableEntity, new()
        {
            try
            {
                Type t = typeof(T);
                CloudTable table = tableClient.GetTableReference(t.Name);

                // table = tableClient.GetTableReference(entity.GetType().Name.ToLower());
                var exQuery = new TableQuery<T>();
                if (null != dict && dict.Count > 0)
                {
                    var keys = dict.Keys;
                    foreach (String key in keys)
                    {
                        if (dict[key] != null && !string.IsNullOrEmpty(dict[key].ToString()))
                        {
                            exQuery.Where(TableQuery.GenerateFilterCondition(key, QueryComparisons.Equal,
                                                                               dict[key].ToString()));
                        }
                    }
                }
                //exQuery. Where(TableQuery.GenerateFilterCondition("PartitionKey", QueryComparisons.Equal,   partitionKey));
               // exQuery.Where(TableQuery.GenerateFilterCondition("Id", QueryComparisons.Equal,    "3e89fded-806f-454a-85fc-7f0360f5a8361"));
                TableContinuationToken continuationToken = null;
                return table.ExecuteQuerySegmentedAsync(exQuery, continuationToken).Result.ToList();

            }
            catch (StorageException ex)
            {
                Trace.TraceInformation("Unable to retrieve entity based on query specs");
                return null;
            }
        }

        public T Save<T>(TableEntity entity) where T : new()
        {
            Type t = typeof(T);
            string name = t.Name;
            CloudTable table = tableClient.GetTableReference(name);
            table.CreateIfNotExistsAsync();
            TableOperation operation = TableOperation.Insert(entity);
            return (T)table.ExecuteAsync(operation).Result.Result;
        }

        public T Update<T>(TableEntity entity) where T : new()
        {
            Type t = typeof(T);
            string name = t.Name;
            CloudTable table = tableClient.GetTableReference(name);
            table.CreateIfNotExistsAsync();
            TableOperation operation = TableOperation.Replace(entity);
            return (T)table.ExecuteAsync(operation).Result.Result;
            throw new NotImplementedException();
        }
    }
}
