﻿using Microsoft.WindowsAzure.Storage.Table;
using System;
using System.Collections.Generic;
using System.Text;

namespace HaBook.IES.AzureCloud.TableStorage.Repositorys
{
   public interface IAzureTableDBRepository
    {
        List<T> GetEntities<T>(IDictionary<string ,object> dict  ) where T : TableEntity, new();
        T FindOneByDict<T>(IDictionary<string, object> dict) where T : TableEntity, new();
        T FindById<T>(string  id ) where T : TableEntity, new();
        T Save<T>(TableEntity entity) where T : new();
        T Update<T>(TableEntity entity) where T : new();
        T DeleteById<T>(object id) where T : new();
        T FindOneByKey<T>(string key, string value) where T :TableEntity , new();
        List<T> FindListByDict<T>(Dictionary<string, object> dict) where T : TableEntity, new();
        List<T> FindListByKey<T>(string key, string value) where T : TableEntity, new();
        List<T> FindAll<T>() where T : TableEntity, new();
        List<T> FindListByDictAndLike<T>(
            Dictionary<string, object> dict,
            Dictionary<string, object> likeDict) where T : TableEntity, new();
        List<T> FindListByDictAndLikeAndStartWith<T>(
            Dictionary<String, Object> dict,
            Dictionary<String, Object> likeDict,
            Dictionary<String, Object> startDict)
            where T : TableEntity, new();
        List<T> FindListByDictAndLikeAndNotEQ<T>(
            Dictionary<String, Object> dict,
            Dictionary<String, Object> likeDict,
            Dictionary<String, Object> notEQDict)
          where T : TableEntity, new();
    }
}
